=== debian/rules ===
#!/usr/bin/make -f

EMPTY =
COMMA = ,
SPACE = $(EMPTY) $(EMPTY)

# Check if DEB_BUILD_OPTIONS contains a comma and break the build
ifneq (,$(findstring $(COMMA),$(DEB_BUILD_OPTIONS)))
$(error DEB_BUILD_OPTIONS contains a comma, which is not supported. Please use spaces to separate options.)
endif

# polly & lldb aren't enabled for every platform
PROJECTS = clang;clang-tools-extra;lld;cross-project-tests;mlir
# openmp & libunwind aren't enabled for every platform

DEB_BUILD_PROFILES := $(DEB_BUILD_PROFILES)
export DEB_BUILD_PROFILES

# FIXME: disable some PROJECTS according to build profiles
#ifeq (,$(filter pkg.llvm.noclang, $(DEB_BUILD_PROFILES)))
#  DEB_BUILD_PROFILES += pkg.llvm.noclang
#  $(warning LLVM PROFILES: enabled build profile pkg.llvm.noclang)
#endif

TARGET_BUILD	:= build-llvm
TARGET_BUILD_STAGE2    := $(TARGET_BUILD)/tools/clang/stage2-bins
d = debian/tmp
DEB_INST		:= $(CURDIR)/$(d)

GXX_VERSIONED_PACKAGE    := $(shell dpkg-query -W -f '$${Depends}' g++ | grep -o 'g++-[0-9][0-9.]*' | tail -n1 )
GXX_VERSIONED_EXECUTABLE := $(shell dpkg -L $(GXX_VERSIONED_PACKAGE) | grep '/usr/bin/g++-[0-9][0-9.]*' | xargs ls -d | tail -n1 )
GCC_VERSION              := $(subst /usr/bin/g++-,,$(GXX_VERSIONED_EXECUTABLE))

PYTHON3 := $(shell py3versions -d)
PY_EXT_SUFFIX := $(shell python3-config --extension-suffix)

PKG_VERSION := $(shell dpkg-parsechangelog | awk '/^Version:/ {print $$2}')
LLVM_EPOCH := 1:
LLVM_VERSION   := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:([0-9]+).*,\1,p")
LLVM_VERSION_FULL := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:([0-9.]+)(~|-)(.*),\1,p")
LLVM_VERSION_MINOR := $(shell echo $(PKG_VERSION)  | sed -rne "s,^1:[0-9]+\.([0-9]+)\.[0-9]+.*,\1,p")
LLVM_VERSION_SNAPSHOT := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:(.*),\1,p")
ifeq ($(LLVM_VERSION),$(LLVM_VERSION_FULL))
	LLVM_VERSION_FULL := $(LLVM_VERSION).0.0
	LLVM_VERSION_MINOR := 0
endif
LLVM_VERSION_NEXT := $(shell echo $(LLVM_VERSION_FULL) | awk -F. '{ OFS="."; $$NF+=1; print}')
LLVM_DIR	= usr/lib/llvm-$(LLVM_VERSION)
LLVM_LIBDIR	= usr/lib/llvm-$(LLVM_VERSION)/lib

# dpkg-buildflags support
# disable fixfilepath in favor of the llvm-project supplied flavor, disable lto
# remove +time64,+lfs once the time64_t transition starts
RUNTIMES = compiler-rt;libcxx;libcxxabi
ifeq ($(DEB_HOST_ARCH_CPU),i386)
  export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
else
  ifeq ($(DEB_HOST_ARCH_BITS),32)
    export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto abi=+time64,+lfs
  else
    ifeq ($(DEB_HOST_ARCH),mips64el)
        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto hardening=-stackprotector,-stackprotectorstrong
    else
        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
    endif
  endif
endif

SOURCE_NAME := $(shell dpkg-parsechangelog -S Source)
ifneq (,$(findstring snapshot,$(SOURCE_NAME)))
  BRANCH_NAME=snapshot
else
  BRANCH_NAME=$(LLVM_VERSION)
endif

VENDOR=$(shell lsb_release -is)
DISTRO=$(shell lsb_release -sc)
DERIVATIVE := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
		elif dpkg-vendor --derives-from Debian; then echo Debian; \
		else echo Unknown; fi)

SONAME_EXT      := 1
SONAME_OPENMP	:= 5
# Manage the case when the version is 3.5~svn213052-1~exp1 or 3.4.2-1
DEBIAN_REVISION := $(shell dpkg-parsechangelog |  sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\3,p")
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
	NCPUS := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
else
	NCPUS := $(shell nproc)
endif

# Check if a package meets version requirement
# Usage: $(call check_pkg_version,package-name,operator,version)
# Operators: ge (>=), gt (>), le (<=), lt (<), eq (=)
# Returns: yes or no
define check_pkg_version
$(shell v=$$(dpkg-query -W -f '$${Version}' $(1) 2>/dev/null); \
        if [ -z "$$v" ]; then \
            echo no; \
        elif dpkg --compare-versions "$$v" $(2) $(3); then \
            echo yes; \
        else \
            echo no; \
        fi)
endef

# Remove RPATH/RUNPATH from files matching a pattern
# Usage: $(call remove_rpath,file-pattern)
# Example: $(call remove_rpath,$(DEB_INST)/$(LLVM_DIR)/bin/*)
define remove_rpath
	for i in \
	  `chrpath -k $(1) 2>/dev/null | awk -F: '/R(UN)?PATH=/ {print $$$$1}'`; \
	do \
	  [ -h $$$$i ] && continue; \
	  chrpath -d $$$$i; \
	  echo "removed RPATH/RUNPATH: $$$$i"; \
	done
endef

# Generate CMAKE compiler and linker flags
# Usage: $(call CMAKE_FLAGS,cflags,cxxflags,ldflags)
# Example: $(call CMAKE_FLAGS,$(STAGE_1_CFLAGS),$(STAGE_1_CXXFLAGS),$(STAGE_1_LDFLAGS))
define CMAKE_FLAGS
-DCMAKE_C_FLAGS="$(1)" \
-DCMAKE_CXX_FLAGS="$(2)" \
-DCMAKE_SHARED_LINKER_FLAGS="$(3)" \
-DCMAKE_MODULE_LINKER_FLAGS="$(3)" \
-DCMAKE_EXE_LINKER_FLAGS="$(3)"
endef

# Generate nested CMAKE args for BUILTINS_CMAKE_ARGS, RUNTIMES_CMAKE_ARGS, etc.
# Usage: $(call CMAKE_NESTED_FLAGS,cflags,cxxflags,ldflags)
# Optional 4th arg for build type (defaults to Release)
# Optional 5th arg for additional flags
define CMAKE_NESTED_FLAGS
-DCMAKE_C_FLAGS=$(1);-DCMAKE_CXX_FLAGS=$(2);-DCMAKE_EXE_LINKER_FLAGS=$(3);-DCMAKE_SHARED_LINKER_FLAGS=$(3);-DCMAKE_MODULE_LINKER_FLAGS=$(3);-DCMAKE_BUILD_TYPE=$(if $(4),$(4),Release);$(if $(5),$(5);)-DLLVM_ENABLE_PER_TARGET_RUNTIME_DIR=OFF
endef

# Generate BOOTSTRAP_CMAKE flags (prepends BOOTSTRAP_ to flag names)
# Usage: $(call BOOTSTRAP_CMAKE_FLAGS,cflags,cxxflags,ldflags)
define BOOTSTRAP_CMAKE_FLAGS
-DBOOTSTRAP_CMAKE_C_FLAGS="$(1)" \
-DBOOTSTRAP_CMAKE_CXX_FLAGS="$(2)" \
-DBOOTSTRAP_CMAKE_SHARED_LINKER_FLAGS="$(3)" \
-DBOOTSTRAP_CMAKE_MODULE_LINKER_FLAGS="$(3)" \
-DBOOTSTRAP_CMAKE_EXE_LINKER_FLAGS="$(3)"
endef

# set this macro to anything else than "yes" to avoid generating alternative
# build dependencies on hello in the control file.
BD_ALT_HELLO = yes
ifeq ($(DERIVATIVE),Ubuntu)
BD_ALT_HELLO = no
endif

ifeq ($(BD_ALT_HELLO),yes)
  BD_ALT_HELLO_SUBST = 's/@BEGIN_OPTIONAL_HELLO@//g;s/@END_OPTIONAL_HELLO@//g'
else
  BD_ALT_HELLO_SUBST = 's/@BEGIN_OPTIONAL_HELLO@.*@END_OPTIONAL_HELLO@//'
endif

SKIP_COMMON_PACKAGES =
# for distro builds, skip these if a newer LLVM is in the distro series
ifeq ($(DERIVATIVE),Ubuntu)
  # list series which should not have the common packages
  ifneq (,$(filter $(DISTRO), series1 series2))
    SKIP_COMMON_PACKAGES = yes
  endif
else ifeq ($(DERIVATIVE),Debian)
  ifneq (,$(filter $(DISTRO), series1 series2))
    SKIP_COMMON_PACKAGES = yes
  endif
endif
# set these two when building without the common packages
#SKIP_COMMON_PACKAGES = yes
#NEW_LLVM_VERSION = 23

ifeq ($(SKIP_COMMON_PACKAGES),yes)
  COMMON_PKGS := $(shell cat debian/packages.common)
  COMMON_BUILD_DEPS = $(foreach p,$(COMMON_PKGS),$(p)$(COMMA))
  # make sure the common packages exist for the new LLVM version
  NEXT_LIBLLVM_PKG = libllvm$(NEW_LLVM_VERSION),
endif

# some object files are removed for space constraints during the build
# uncomment to keep everything during a build
# a SMALL_DISK build is 15GB + <2GB in the parent directory, the full build
# peaks out at 35GB + <2GB for the parent directory.
#SMALL_DISK = yes

# use sloppy builds to collect to
#   - ignore additional build artifacts
#   - ignore missing symbols in libraries
# look at these in the build logs and fix them in follow-up uploads
SLOPPY_BUILD =
ifeq (,$(filter $(DEB_HOST_ARCH), amd64XXX arm64XXX))
	SLOPPY_BUILD = yes
	ignore_if_fail = -
endif

# this contains all packages to be built. Note that for at least the clean target,
# this always includes the binary-indep packages.
packages := $(shell dh_listpackages)

# no 32bit support
FLANG_ARCHS := amd64 arm64 ppc64el ppc64 sparc64 riscv64 loong64

ifneq (,$(filter $(DEB_HOST_ARCH), $(FLANG_ARCHS)))
# this doesn't work, Ubuntu passes these in both positive and negative form, filter later
